<?php
// URL of the DeviantArt page
$url = "https://www.deviantart.com/aoimatsuri/art/2024-07-22-Smiling-Sky-1078095913";

// Set up a context with a proper user agent header
$options = [
    "http" => [
        "header" => "User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.3\r\n"
    ]
];
$context = stream_context_create($options);

// Fetch the page content
$pageContent = file_get_contents($url, false, $context);

// Create a DOMDocument object and load the HTML content
$dom = new DOMDocument;
libxml_use_internal_errors(true);
$dom->loadHTML($pageContent);
libxml_clear_errors();

// Initialize XPath
$xpath = new DOMXPath($dom);

// Define XPath queries to get views and favorites
$viewsQuery = "//*[@data-hook='deviation_meta_stats']/span[@title='Views']/text()";
$favoritesQuery = "//*[@data-hook='deviation_meta_stats']/span[@title='Favorites']/text()";

// Execute XPath queries
$views = $xpath->query($viewsQuery)->item(0)->nodeValue ?? 'N/A';
$favorites = $xpath->query($favoritesQuery)->item(0)->nodeValue ?? 'N/A';

// Display the results
echo "Views: " . htmlspecialchars($views) . "<br>";
echo "Favorites: " . htmlspecialchars($favorites);
?>
