<?php
// URL of the DeviantArt page
$url = "https://www.deviantart.com/aoimatsuri/art/2024-07-22-Smiling-Sky-1078095913";

// Set up a context with a proper user agent header
$options = [
    "http" => [
        "header" => "User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.3\r\n"
    ]
];
$context = stream_context_create($options);

// Fetch the page content
$pageContent = file_get_contents($url, false, $context);

// Check if content was fetched
if ($pageContent === false) {
    die("Error fetching page content");
}

// Find the JSON data in the page content
$pattern = '/"stats":{[^}]+}/';
if (preg_match($pattern, $pageContent, $matches)) {
    $statsJson = '{' . $matches[0] . '}';
    $stats = json_decode($statsJson, true);

    if (json_last_error() === JSON_ERROR_NONE) {
        $views = $stats['stats']['views'] ?? 'N/A';
        $favorites = $stats['stats']['favourites'] ?? 'N/A';
    } else {
        $views = $favorites = 'N/A';
    }
} else {
    $views = $favorites = 'N/A';
}

// Display the results
echo "Views: " . htmlspecialchars($views) . "<br>";
echo "Favorites: " . htmlspecialchars($favorites);
?>
