<?php
// Standard DeviantArt URL
$url = "https://www.deviantart.com/aoimatsuri/art/2024-07-22-Smiling-Sky-1078095913";

// Set up a context with a proper user agent header
$options = [
    "http" => [
        "header" => "User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.149 Safari/537.36\r\n"
    ]
];
$context = stream_context_create($options);

// Fetch the page content
$pageContent = file_get_contents($url, false, $context);

// Check if content was fetched
if ($pageContent === false) {
    die("Error fetching page content");
}

// Extract deviation ID from URL
preg_match('/-(\d+)$/', parse_url($url, PHP_URL_PATH), $matches);
$deviationId = $matches[1] ?? null;

if (!$deviationId) {
    die("Invalid URL or Deviation ID not found.");
}

// Find the JSON data in the page content
$pattern = '/{"deviationId":' . $deviationId . '[^}]+,"media":/';
if (preg_match($pattern, $pageContent, $matches)) {
    // Extract JSON string up to but not including "media"
    $jsonString = rtrim($matches[0], ',"media":');
    $jsonString .= '}';

    $data = json_decode($jsonString, true);

    if (json_last_error() === JSON_ERROR_NONE) {
        $views = $data['stats']['views'] ?? 'N/A';
        $favorites = $data['stats']['favourites'] ?? 'N/A';
    } else {
        $views = $favorites = 'N/A';
    }
} else {
    $views = $favorites = 'N/A';
}

// Display the results
echo "Views: " . htmlspecialchars($views) . "<br>";
echo "Favorites: " . htmlspecialchars($favorites);
?>
