<base href="https://yugioh.fandom.com">

<!DOCTYPE html>
<html>
<head>
    <title>Yu-Gi-Oh! Card Viewer</title>
</head>
<body>
    <form method="get" action="">
        <label for="url">Enter Card URL:</label>
        <input type="text" id="url" name="url" required>
        <input type="submit" value="Submit">
    </form>
    <hr>
    <?php
    if (isset($_GET['url'])) {
        // Get the URL parameter value
        $url = $_GET['url'];

        // Initialize cURL
        $curl = curl_init();

        // Set the cURL options
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.3');

        // Execute the cURL request
        $response = curl_exec($curl);

        // Check for cURL errors
        if ($response === false) {
            die('Error: ' . curl_error($curl));
        }

        // Close cURL
        curl_close($curl);

        // Find the position of the starting and ending strings
        $startPos = strpos($response, '<table class="cardtable cardtable-link">');
        $endPos = strpos($response, '</tbody></table><table class="navbox hlist">');

        // Check if the starting string is found
        if ($startPos !== false) {
            // Extract the content between the starting and ending strings
            $content = substr($response, $startPos, $endPos - $startPos);

            // Convert image URLs to base64
            $content = preg_replace_callback('/(<img[^>]+src=")([^"]+)("[^>]*>)/i', function ($matches) {
                $imageUrl = $matches[2];
                $imageData = base64_encode(file_get_contents($imageUrl));
                return $matches[1] . 'data:image/png;base64,' . $imageData . $matches[3];
            }, $content);

            // Output the extracted content with base64-encoded images
            echo $content;
        } else {
            // Find the position of the fallback string
            $fallbackStartPos = strpos($response, '<table class="cardtable">');
            $fallbackEndPos = strpos($response, '</table>', $fallbackStartPos);

            // Check if the fallback string is found
            if ($fallbackStartPos !== false && $fallbackEndPos !== false) {
                // Extract the fallback content
                $fallbackContent = substr($response, $fallbackStartPos, $fallbackEndPos - $fallbackStartPos + 8);

                // Convert image URLs to base64
                $fallbackContent = preg_replace_callback('/(<img[^>]+src=")([^"]+)("[^>]*>)/i', function ($matches) {
                    $imageUrl = $matches[2];
                    $imageData = base64_encode(file_get_contents($imageUrl));
                    return $matches[1] . 'data:image/png;base64,' . $imageData . $matches[3];
                }, $fallbackContent);

                // Output the fallback content with base64-encoded images
                echo $fallbackContent;
            } else {
                // If both strings are not found, display an error message
                echo "Content not found.";
            }
        }
    }
    ?>
</body>
</html>


<script>
    //var urlParams = new URLSearchParams(window.location.search); //wont work with " & " cards
    //var card = urlParams.get('card'); 
    var url = window.location.href;
    var card = '';
    if (url.includes('?card=')) {card = url.split('?card=')[1].replace(/#38;/g, '');}

    if (card !== null && card !== '') {
        var newUrl = window.location.protocol + "//" + window.location.host + window.location.pathname;
        window.history.replaceState({}, document.title, newUrl);
        //document.getElementsByName('url')[0].value = card;
        document.getElementById('url').value = card; //filltextbox
        var submitButton = document.querySelector('input[type="submit"]');

// Simulate button click
submitButton.click();
}
</script>
