<?php
//$url = isset($_GET['url']) ? $_GET['url'] : '';
$url = isset($_GET['url']) ? $_GET['url'] : '';
$ebayurl = isset($_GET['ebayurl']) ? $_GET['ebayurl'] : '';
if (empty($url) && empty($ebayurl)) {
    // Neither URL nor ebayurl provided, terminate the script
    exit('No URL provided.');
}

// Continue with the rest of the code if URL is provided
// ...

$price = $_GET['price'];
$title = $_GET['title'];
if (isset($_GET['ebayurl']) && !isset($_GET['url'])) {
    $url = $_GET['ebayurl'];
    $marketplace = 'ebay';
} else {
    $marketplace = '';
}
$date = date('Y-m-d');
$buylistFile = 'buylist.json';
$currentBuylist = [];
if (file_exists($buylistFile)) {
    $currentBuylist = json_decode(file_get_contents($buylistFile), true);
}
$isDuplicate = false;
foreach ($currentBuylist as $item) {
    if ($item['date'] === $date && $item['title'] === $title) {
        $isDuplicate = true;
        break;
    }
}
if (!$isDuplicate) {
    // Create a new item for the buylist
    $newItem = [
        'url' => $url,
        'price' => $price,
        'title' => $title,
        'marketplace' => $marketplace,
        'date' => $date
    ];
    array_unshift($currentBuylist, $newItem);
    file_put_contents($buylistFile, json_encode($currentBuylist, JSON_PRETTY_PRINT));
    echo 'Item added to the <a target=_blank href=buylist.json>buylist</a>!';
} else {
    echo 'Item is a duplicate and not added to the <a target=_blank href=buylist.json>buylist</a>.';
}
?>
