<?php
// Set the initial value of the Pinterest page URL
$url = "";

// Check if the query string parameter "pinurl" exists
if (isset($_GET['pinurl'])) {
    // Retrieve the value of the "pinurl" parameter
    $url = $_GET['pinurl'];
}

if (isset($_POST['url'])) {
    // Pinterest page URL
    $url = $_POST['url'];
}

if (isset($_POST['url']) || isset($_GET['pinurl'])) {
    // Fetch the HTML content of the Pinterest page
    $html = file_get_contents($url);

    // Regular expression pattern to match the image URL with the specified attributes
    $pattern = '/fetchpriority="auto" loading="auto" src="(.*?)" elementtiming="closeupImage"/';

    // Execute the regular expression and extract the image URL
    preg_match($pattern, $html, $matches);

    if (isset($matches[1])) {
        $imageURL = $matches[1];

        // Create an HTML link with target blank and the extracted image URL
        $linkTag = '<a href="' . $imageURL . '" target="_blank">View Image</a>';

        // Create an HTML img tag with the extracted image URL and 50% width
        $imageTag = '<img src="' . $imageURL . '" width="50%" />';

        // Output the link and the image tag
        echo "Image URL with specified attributes: " . $linkTag . "<br>";
        echo $imageTag;
        // You can now use $imageURL to display or process the image
    } else {
        echo "No image found with the specified attributes.";
    }
}
?>

<!DOCTYPE html>
<html>
<head>
    <title>Image URL Extraction</title>
</head>
<body>
    <form method="POST" action="">
        <label for="url">Pinterest Page URL:</label><br>
        <input type="text" id="url" name="url" placeholder="Enter Pinterest page URL" value="<?php echo $url; ?>">
        <button type="submit">Extract Image URL</button>
    </form>
</body>
</html>