<?php
$filePath = 'https://alceawis.de/pixiv-artworks-archive.html';
$html = file_get_contents($filePath);
if ($html === false) {
echo 'Failed to read the file "'.$filePath.'".';
exit;}
$dom = new DOMDocument();
libxml_use_internal_errors(true); // Suppress HTML parsing errors
$loaded = $dom->loadHTML($html);
if (!$loaded) {
echo 'Failed to parse the HTML content.';
exit;}
$xpath = new DOMXPath($dom);
$artworkLinks = $xpath->query('//a[@target="_blank"]');
$filteredArtworkLinks = [];
foreach ($artworkLinks as $link) {
$linkUrl = $link->getAttribute('href');
if (!strpos($link->textContent, '»') && strpos($linkUrl, 'pixivurl') === false) {
$filteredArtworkLinks[] = $linkUrl;}}
if (empty($filteredArtworkLinks)) {
echo 'No valid artwork links found.';
exit;}
$thumbnailUrls = [];
$options = [
'http' => [
'header' => "User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:70.0) Gecko/20100101 Firefox/70.0\r\n" .
"Referer: https://accounts.pixiv.net\r\n",
],];
$context = stream_context_create($options);
for ($i = 0; $i < 10; $i++) {
$randomIndex = array_rand($filteredArtworkLinks);
$randomLink = $filteredArtworkLinks[$randomIndex];
$url = $randomLink;
$html = file_get_contents($url, false, $context);
if ($html === false) {
echo 'Failed to fetch the HTML content for the artwork: '.$url.'<br>';
continue;}
$pattern = '/"thumb":"(.*?)"/';
preg_match($pattern, $html, $matches);
if (!isset($matches[1])) {
echo 'Failed to extract the thumbnail URL for the artwork: '.$url.'<br>';
continue;}
$thumbnailUrl = json_decode('"'.$matches[1].'"'); // Decode the URL-encoded JSON string
$imageData = file_get_contents($thumbnailUrl, false, $context);
if ($imageData !== false) {
$base64 = base64_encode($imageData);
$imageSrc = 'data:image/jpeg;base64,' . $base64;
echo '<a href="' . $randomLink . '" target="_blank"><img src="' . $imageSrc . '" alt="Image" width=100px></a> ';
} else {
echo 'Failed to retrieve the image: '.$thumbnailUrl.'<br>';
}}
?>

<unique>
<button onclick="savePageAsHTML()">Save Page as HTML</button>
<script>
function savePageAsHTML() {
var placeholder = document.querySelector('unique');
placeholder.parentNode.removeChild(placeholder);
var html = document.documentElement.outerHTML;
var filename = 'pixivreel.html';
var element = document.createElement('a');
element.setAttribute('href', 'data:text/html;charset=utf-8,' + encodeURIComponent(html));
element.setAttribute('download', filename);
element.style.display = 'none';
document.body.appendChild(element);
element.click();
document.body.removeChild(element);
document.body.appendChild(placeholder);
}
</script>
</unique>
