<meta charset="UTF-8">
<?php ini_set('default_charset', 'UTF-8'); ?>
    <title>PHP List Writer</title>
    <style>
        table {
            width: 100%;
            border-collapse: collapse;
        }

        table, th, td {
            border: 1px solid black;
            padding: 5px;
        }
    </style>
    <script>
        function loadEntries() {
            var xmlhttp = new XMLHttpRequest();
            xmlhttp.onreadystatechange = function() {
                if (this.readyState == 4 && this.status == 200) {
                    var entries = JSON.parse(this.responseText);
                    var table = document.getElementById("entriesTable");
                    table.innerHTML = ""; // Clear existing table content

                    if (entries.length > 0) {
                        var headerRow = table.insertRow();
                        headerRow.innerHTML = "<th>Name</th><th>URL</th><th>Date</th><th>Format</th><th>Password</th><th>Description</th>";

                        for (var i = 0; i < entries.length; i++) {
                            var entry = entries[i];
                            var row = table.insertRow();
                            row.innerHTML = "<td>" + entry.name + "</td><td>" + entry.url + "</td><td>" + entry.date + "</td><td>" + entry.format + "</td><td>" + entry.password + "</td><td>" + entry.description + "</td>";
                        }
                    } else {
                        var noEntriesRow = table.insertRow();
                        noEntriesRow.innerHTML = "<td colspan='6'>No entries found.</td>";
                    }
                }
            };
           var cacheBuster = new Date().getTime();
           xmlhttp.open("GET", "modeldata.json?t=" + cacheBuster, true);
            xmlhttp.send();
        }
    </script>
</head>
<body>
    <h2>PHP List Writer</h2>

    <?php
    // Check if the form is submitted
    if ($_SERVER['REQUEST_METHOD'] === 'POST') {
        // Retrieve form data
        $name = $_POST['name'];
        $url = $_POST['url'];
        $date = $_POST['date'];
        $format = $_POST['format'];
        $password = $_POST['password'];
        $description = $_POST['description'];

        // Create an array with the form data
        $data = array(
            'name' => $name,
            'url' => $url,
            'date' => $date,
            'format' => $format,
            'password' => $password,
            'description' => $description
        );

        // Read existing entries from the JSON file
        $filename = 'modeldata.json';
        $entries = array();
        if (file_exists($filename)) {
            $json_data = file_get_contents($filename);
            $entries = json_decode($json_data, true);
        }

        // Prepend the new entry to the array
        array_unshift($entries, $data);

        // Encode the updated data as JSON
        $json = json_encode($entries);

        // Save the JSON data to the file
        file_put_contents($filename, $json);

        echo 'Data saved successfully!';
    }
    ?>

    <form method="POST" action="<?php echo $_SERVER['PHP_SELF']; ?>">
        <label for="name">Name:</label>
        <input type="text" name="name" id="name" required><br><br>

        <label for="url">URL:</label>
        <input type="text" name="url" id="url" required><br><br>

        <label for="date">Date:</label>
        <input type="date" name="date" id="date" value="<?php echo date('Y-m-d'); ?>" required><br><br>

        <label for="format">Format:</label>
        <select name="format" id="format">
            <option value="pmx">PMX</option>
            <option value="pmd">PMD</option>
            <option value="pmx">Stage-Prop</option>
        </select><br><br>
        <label for="password">Password:</label>
        <input type="text" name="password" id="password" required value="-"><br><br>
        <label for="description">Description:</label>
        <input type="text" name="description" id="description" required value="-"><br><br>
        <input type="submit" value="Save">
    </form>
    <h3>Current Entries:</h3>
    <table id="entriesTable">
        <tr>
            <th>Name</th>
            <th>URL</th>
            <th>Date</th>
            <th>Format</th>
            <th>Password</th>
            <th>Description</th>
        </tr>
    </table>

    <button onclick="loadEntries()">Load Entries</button>
</body>


    <button onclick="exportTable()">Export Table</button>

    <script>
        function exportTable() {
            var table = document.getElementById("entriesTable").outerHTML;
            var htmlContent = "<html><head><meta charset='UTF-8'><head><title>Exported Table</title></head><body>" + table + "</body></html>";

            var link = document.createElement("a");
            link.href = "data:text/html;charset=utf-8," + encodeURIComponent(htmlContent);
            link.download = "modeldata.html";
            link.click();
        }
    </script>
