<?php
error_reporting(0);
?>

<style>
    .grid-container {
        display: flex;
        flex-wrap: wrap;
        justify-content: flex-start;
    }

    .grid-item {
        flex: 0 0 20%;
        margin: 0;
        padding: 0;
    }

    .grid-item img {
        display: block;
        margin: 0;
        padding: 0;
    }
</style>

<?php
$url = $_POST['url'] ?? '';
$deckname = $_POST['deckname'] ?? '';
$output = "";
// Create the deck/$deckname directory if $deckname is not empty
if (!empty($deckname)) {
    $directoryPath = "deck/$deckname";
    if (!is_dir($directoryPath)) {
        mkdir($directoryPath, 0777, true);
    }
}

if (!empty($url)) {
    $content = file_get_contents($url);
    if ($content !== false) {
        $lines = explode("\n", $content);

        foreach ($lines as $line) {
            if (is_numeric($line)) {
                $number = preg_replace('/[^0-9]/', '', $line);
                if (!empty($deckname)) {
                    $imageLink = "https://images.ygoprodeck.com/images/cards/$number.jpg";
                    $imageData = file_get_contents($imageLink);
                    $base64Data = base64_encode($imageData);
                    $imageType = mime_content_type($imageLink);
                    $encodedImage = 'data:' . $imageType . ';base64,' . $base64Data;
                    $output .= "<div class='grid-item'><img src='" . $encodedImage . " ' width=268 height=390></div>";
                    // Copy the image to the deck/$deckname folder
                    $imageName = "$number.jpg";
                    $destinationPath = "deck/$deckname/$imageName";
                    file_put_contents($destinationPath, $imageData);
                } else {
                    $output .= "<a href='https://images.ygoprodeck.com/images/cards/$number.jpg'>$number</a><br>";
                }
            } elseif (strpos($line, '!side') !== false) {
                $output .= "<br>SIDEDECK<br>";
            } elseif (strpos($line, '#extra') !== false) {
                $output .= "<br>EXTRADECK<br>";
            }
        }

        if (!empty($deckname)) {
            $output = "<div class='grid-container'>$output</div>";
        }
    } else {
        $output = "Failed to retrieve content from the provided URL.";
    }
} elseif (!empty($_FILES['file']['tmp_name'])) {
    $file = $_FILES['file']['tmp_name'];
    $content = file_get_contents($file);
    $lines = explode("\n", $content);

    foreach ($lines as $line) {
        if (is_numeric($line)) {
            $number = preg_replace('/[^0-9]/', '', $line);
            if (!empty($deckname)) {
                $imageLink = "https://images.ygoprodeck.com/images/cards/$number.jpg";
                $imageData = file_get_contents($imageLink);
                $base64Data = base64_encode($imageData);
                $imageType = mime_content_type($imageLink);
                $encodedImage = 'data:' . $imageType . ';base64,' . $base64Data;
                $output .= "<div class='grid-item'><img src='" . $encodedImage . "' width=268 height=390></div>";

                // Copy the image to the deck/$deckname folder
                $imageName = "$number.jpg";
                $destinationPath = "deck/$deckname/$imageName";
                file_put_contents($destinationPath, $imageData);
            } else {
                $output .= "<a href='https://images.ygoprodeck.com/images/cards/$number.jpg'>$number</a>";
            }
        } elseif (strpos($line, '!side') !== false) {
            $output .= "";
        } elseif (strpos($line, '#extra') !== false) {
            $output .= "";
        }
    }

    if (!empty($deckname)) {
        $output = "<div class='grid-container'>$output</div>";
    }
}

echo $output;
?>
