<?php
use Goutte\Client;

// Check if the form is submitted
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Get the submitted URL from the textbox
    $url = $_POST['url'];

    // Validate the URL (you can add your own validation logic here)
    if (!filter_var($url, FILTER_VALIDATE_URL)) {
        echo 'Invalid URL';
        exit;
    }

    // Get the absolute path to the vendor directory
    $vendorPath = __DIR__ . '/../vendor';

    // Require the autoload.php file using the absolute path
    require $vendorPath . '/autoload.php';

    // Create a Goutte client
    $client = new Client();

    // Fetch the page content
    $crawler = $client->request('GET', $url);

    // Extract the rendered content
    $content = $crawler->html();

    // Output the rendered content
    echo $content;
}
?>

<!DOCTYPE html>
<html>
<head>
    <title>URL Renderer</title>
</head>
<body>
    <form method="POST" action="">
        <input type="text" name="url" placeholder="Enter URL" required>
        <button type="submit">Render</button>
    </form>
</body>
</html>