<details><summary>Fix Endcoding issues</summary>
<textarea><meta charset="utf-8"></textarea>
</details>

<?php
// Check if the "edit" query parameter is present
if (isset($_GET['edit'])) {
    $file_path = $_GET['edit'];

    // Check if the file exists
    if (file_exists($file_path)) {
        // Read the contents of the HTML file
        $html_content = file_get_contents($file_path);
        $original_timestamp = filemtime($file_path);

        // Display the WYSIWYG editor
        echo '<!DOCTYPE html>
        <html>
        <head>
            <title>Edit HTML File</title>
            <script src="https://cdn.jsdelivr.net/npm/jquery@3.6.0/dist/jquery.min.js"></script>
            <script src="https://cdn.jsdelivr.net/npm/summernote@0.8.18/dist/summernote.min.js"></script>
            <link href="https://cdn.jsdelivr.net/npm/summernote@0.8.18/dist/summernote.min.css" rel="stylesheet">
        </head>
        <body>
            <h1>Edit HTML File</h1>
            <textarea id="html-editor">' . $html_content . '</textarea>

            <script>
                $(document).ready(function() {
                    $("#html-editor").summernote({
                        height: 500,
                        toolbar: [
                            ["style", ["style"]],
                            ["font", ["bold", "underline", "clear"]],
                            ["color", ["color"]],
                            ["para", ["ul", "ol", "paragraph"]],
                            ["table", ["table"]],
                            ["insert", ["link", "picture", "video"]],
                            ["view", ["fullscreen", "codeview", "help"]]
                        ],
                        callbacks: {
                            onChange: function(contents, $editable) {
                                // Update the textarea with the current contents
                                $("#html-editor").val(contents);
                            }
                        }
                    });
                });
            </script>
        </body>
        </html>';
    } else {
        echo '<p>File not found: ' . $file_path . '</p>';
    }
} else {
    echo '<p>No file selected to edit.</p>';
}
?>


<!---------save----->

<button id="save-btn">Save</button>
<script>
  var htmlEditor = document.getElementById("html-editor");
  document.getElementById("save-btn").addEventListener("click", function() {
    var htmlContent = htmlEditor.value;
    localStorage.setItem("html-content", htmlContent);
    sendContentToServer(htmlContent);
  });

  function sendContentToServer(content) {
    // Get the current URL and extract the "edit" querystring
    var url = new URL(window.location.href);
    var editParam = url.searchParams.get("edit");

    var xhr = new XMLHttpRequest();
    xhr.open("POST", "save.php?file=" + encodeURIComponent(editParam), true);
    xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhr.send("content=" + encodeURIComponent(content));
    xhr.onreadystatechange = function() {
      if (xhr.readyState === XMLHttpRequest.DONE && xhr.status === 200) {
        // Display the server response
        alert(xhr.responseText);
      }
    };
  }
</script>