    <script>
        document.addEventListener('DOMContentLoaded', function() {
            const savedNumber = localStorage.getItem('number1');
            if (savedNumber !== null) {
                document.getElementById('number1').value = savedNumber;
            }
        });
    </script>

<?php
// Check if the form has been submitted
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Get the selected name, the two numbers, and the info field from the form
    $selectedName = $_POST['name'];
    $numberField1 = $_POST['number1'];
    $numberField2 = $_POST['number2'];
    $infoField = $_POST['info'];

    // Construct the data array
    $data = array(
        'name' => $selectedName,
        'number1' => $numberField1,
        'number2' => $numberField2,
        'info' => $infoField
    );

    // Convert the data array to JSON
    $json = json_encode($data);

    // Check if the file exists
    $filename = $selectedName . '_data.json';
    if (file_exists($filename)) {
        // If the file exists, read the existing data
        $existingData = file_get_contents($filename);
        $existingData = json_decode($existingData, true);

        // Prepend the new data to the existing data
        array_unshift($existingData, $data);

        // Convert the updated data back to JSON and write it to the file
        $updatedData = json_encode($existingData);
        file_put_contents($filename, $updatedData);
    } else {
        // If the file doesn't exist, create a new file with the data
        file_put_contents($filename, "[$json]");
    }

    // Store the first number and the info field in the local storage
    echo "<script>
        localStorage.setItem('number1', '$numberField1');
        localStorage.setItem('info', '$infoField');
    </script>";

    // Optionally, you can display a success message or redirect the user to another page
    echo "Data saved to " . $filename;
}

// Check if the first number and info field are stored in the local storage
$storedNumber1 = isset($_POST['number1']) ? $_POST['number1'] : (isset($_COOKIE['number1']) ? $_COOKIE['number1'] : '');
$storedInfo = isset($_POST['info']) ? $_POST['info'] : (isset($_COOKIE['info']) ? $_COOKIE['info'] : '');
?>
<!DOCTYPE html>
<html>
<head>
<script>
        function incrementNumber1() {
            var number1Field = document.getElementById("number1");
            var number1Value = number1Field.value;
            
            // Get the length of the original value to preserve the format
            var originalLength = number1Value.length;
            
            // Increment the numeric value
            var incrementedValue = (parseInt(number1Value, 10) + 1).toString();
            
            // Add leading zeros if necessary to maintain the original length
            while (incrementedValue.length < originalLength) {
                incrementedValue = '0' + incrementedValue;
            }
            
            // Update the field value and localStorage
            number1Field.value = incrementedValue;
            localStorage.setItem('number1', incrementedValue);
        }
</script>

</head>
<body>
    <h1>Name Selection</h1>
    <form method="post" action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]);?>">
        <label for="name">Select a name:</label>
        <select name="name" id="name">
            <option value="Aoi">Aoi</option>
            <option value="Ryoken">Ryoken</option>
            <option value="Kusanagi">Kusanagi</option>
            <option value="Shima">Shima</option>
        </select>

        <br><br>

        <label for="number1">Number 1 (any number):</label>
        <input type="number" name="number1" id="number1" value="<?php echo $storedNumber1; ?>" required>
        <button type="button" onclick="incrementNumber1()">+1</button>

        <br><br>

        <label for="number2">Number 2 (-5 to 5):</label>
        <input type="number" name="number2" id="number2" min="-5" max="5" required>

        <br><br>

        <label for="info">Info:</label>
        <input type="text" name="info" id="info" value="<?php echo $storedInfo; ?>" required>

        <br><br>

        <input type="submit" name="submit" value="Submit">
    </form>
</body>
</html>