<?php
// Get the profile ID from the query string
$profile = isset($_GET['profile']) ? $_GET['profile'] : 'alceawisteria'; // Replace 'defaultProfile' with a default value if needed

// Fetch the HTML content
$html = file_get_contents("https://steamcommunity.com/id/$profile");
// Load the HTML into a DOMDocument
libxml_use_internal_errors(true); // Suppress HTML parsing errors
$dom = new DOMDocument();
$dom->loadHTML($html);
libxml_clear_errors(); // Clear HTML parsing errors

// Initialize variables
$gameFound = false;
$achievementSection = null;

// Find all the div elements
$elements = $dom->getElementsByTagName('div');

// Loop through the div elements and find the game and achievement sections
foreach ($elements as $element) {
    $classAttribute = $element->getAttribute('class');

    // Check for the recent game element
    if (!$gameFound && strpos($classAttribute, 'recent_game') !== false) {
        // Get the game info
        $gameInfo = $element->getElementsByTagName('div')->item(0);
        $gameCapsule = $gameInfo->getElementsByTagName('img')->item(0)->getAttribute('src');
        $gameTitle = $gameInfo->getElementsByTagName('a')->item(0)->nodeValue;
        $totalPlaytime = $gameInfo->getElementsByTagName('div')->item(1)->nodeValue;
        $lastPlayed = $gameInfo->getElementsByTagName('div')->item(2)->nodeValue;

        // Get the achievement info
        $achievementInfo = $element->getElementsByTagName('div')->item(1);
        $achievementSummary = $achievementInfo->getElementsByTagName('span')->item(0)->nodeValue;
        $achievementProgress = $achievementInfo->getElementsByTagName('div')->item(0)->getAttribute('style');

        // Extract the relevant information
        $achievementCount = explode(' ', $achievementSummary)[1];
        $achievementTotal = explode('/', $achievementCount)[1];
        $achievementProgress = str_replace('width: ', '', str_replace('%', '', $achievementProgress));

        // Display the game information with the background image
        echo "<div style='width: 300px; max-height: 220px; overflow: hidden; margin: 0px; background: url($gameCapsule) no-repeat center center; background-size: cover; padding: 0px; border-radius: 10px; color: #fff; box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1); position: relative;'>";

        echo "<div style='background: rgba(0, 0, 0, 0.3); padding: 10px; border-radius: 10px;'>";
         echo '<a target="_blank" href="https://steamcommunity.com/id/' . $profile . '" style="color:white">Last Played</a>';
        //echo '<u>Last Played</u> <a target="_blank" href="https://steamcommunity.com/id/' . $profile . '" style="color:pink">' . $profile . '</a>';
        echo "<p>Total Playtime: $totalPlaytime</p>";
        //echo "<p>Last Played: $lastPlayed</p>";
        //echo "<p>Achievements: $achievementCount out of $achievementTotal ($achievementProgress%)</p>";
        echo "</div>";

        echo "</div>";
        
        $gameFound = true; // Mark the game as found
    }

    // Check for the achievement section
    if (strpos($classAttribute, 'game_info_achievements_only_ctn') !== false) {
        $achievementSection = $element;
    }
}

// If the achievement section is found, extract and display the achievement information
if ($achievementSection) {
    $achievementSummary = $achievementSection->getElementsByTagName('span')->item(0)->textContent;
    $achievementProgressBar = $achievementSection->getElementsByTagName('div')->item(1);
    $achievementProgressStyle = $achievementProgressBar->getAttribute('style');
    $achievementCount = trim(explode('/', $achievementSummary)[0]);
    $achievementTotal = trim(explode('/', $achievementSummary)[1]);
    $achievementProgress = str_replace('width: ', '', str_replace('%', '', $achievementProgressStyle));

    echo "<div class='game_info_achievements_summary_area'>";
    // Display achievement information here if needed
    echo "</div>";
}

// If no recent game is found, display a message
if (!$gameFound) {
    echo "No recent games found.";
}
?>
