<?php
// Get the profile ID from the query string
$profile = isset($_GET['profile']) ? $_GET['profile'] : 'alceawisteria'; // Replace 'alceawisteria' with a default profile if needed

// Fetch the HTML content
$html = file_get_contents("https://steamcommunity.com/id/$profile");

// Load the HTML into a DOMDocument
libxml_use_internal_errors(true); // Suppress HTML parsing errors
$dom = new DOMDocument();
$dom->loadHTML($html);
libxml_clear_errors(); // Clear HTML parsing errors

// Initialize variables
$gameFound = false;
$achievementSection = null;

// Find all div elements with class 'profile_badges'
$elements = $dom->getElementsByTagName('div');

// Loop through the div elements and find the badges section
foreach ($elements as $element) {
    $classAttribute = $element->getAttribute('class');

    // Check for the badges section
    if (strpos($classAttribute, 'profile_badges') !== false) {
        // Find all badge elements
        $badges = $element->getElementsByTagName('div');

        // Loop through badges and extract information
        foreach ($badges as $badge) {
            $badgeClass = $badge->getAttribute('class');
            
            // Check for individual badge elements
            if (strpos($badgeClass, 'profile_badges_badge') !== false) {
                $badgeTitle = $badge->getAttribute('data-tooltip-html');

                // Extract badge title and parse it for information
                preg_match('/<br\/?>/', $badgeTitle, $matches);
                $badgeDetails = explode($matches[0], $badgeTitle);
                $badgeName = strip_tags($badgeDetails[0]);
                $badgeDescription = strip_tags($badgeDetails[1]);

                // Get the badge image URL
                $badgeImage = $badge->getElementsByTagName('img')->item(0)->getAttribute('src');

                // Display the badge information
                echo "<div style='width: 200px; margin: 10px; float: left; text-align: center;'>";
                echo "<img src='$badgeImage' alt='$badgeName'><br>";
                echo "<strong>$badgeName</strong><br>";
                echo "<small>$badgeDescription</small>";
                echo "</div>";
            }
        }
    }
}

// If no badges found, display a message
if (!$gameFound) {
    echo "No badges found for this profile.";
}
?>
